      SUBROUTINE UCASE (S,T)
C String procedure * Lower case -> upper case
C
      CHARACTER S*(*), T*(*)
      N=MIN0(LEN(S),LEN(T))
      DO 101 I=1,N
      J=ICHAR(S(I:I))
      IF (J.GT.96.AND.J.LT.123) J=J-32
      T(I:I)=CHAR(J)
101   CONTINUE
      END

      SUBROUTINE LCASE (S,T)
C String procedure * Lower case <- upper case
C
      CHARACTER S*(*), T*(*)
      N=MIN0(LEN(S),LEN(T))
      DO 101 I=1,N
      J=ICHAR(S(I:I))
      IF (J.GT.64.AND.J.LT.91) J=J+32
      T(I:I)=CHAR(J)
101   CONTINUE
      END

      subroutine delete_1_in_string (s,c,m,n)
      character s*(*),c*(*)
      nn=n
      mm=max0(1,m)
      ls=index_l_nonblank(s)
      if (n.le.0) nn=ls
      lc=index_l_nonblank(c)
      if (c.eq.' ') lc=1
      i=index(s(mm:nn),c)+mm-1
      if (i.lt.mm) return
      lc1=lc-1
      s(i:nn-lc)=s(i+lc:nn)
      s(nn-lc1:nn)=' '
      return
      end

      subroutine delete_l_in_string (s,c,m,n)
      character s*(*),c*(*)
      nn=n
      mm=max0(1,m)
      ls=index_l_nonblank(s)
      if (n.le.0) nn=ls
      lc=index_l_nonblank(c)
      if (c.eq.' ') lc=1
      i=index_l(s(mm:nn),c)+mm-1
      if (i.lt.mm) return
      lc1=lc-1
      s(i:nn-lc)=s(i+lc:nn)
      s(nn-lc1:nn)=' '
      return
      end

      subroutine delete_in_string (s,c,m,n)
c String utility * Delete c in s
c
c Deletes string C in string  S(m:n)  by moving text leftward until len(s)
c
      character s*(*), c*(*)
      ls=index_l_nonblank(s)
      if (ls.lt.1) ls=len(s)
      if (n.gt.0) ls=min0(n,ls)
      lc=len(c)
      
      if (index(s(:ls),c).eq.ls-lc+1) then
         s(ls-lc+1:)=' '
         return
      endif

      if (c.eq.' ') lc=1
      lc1=lc-1
      k=lc1
      i=m-1

 101  i=index(s(m:ls),c)+m-1
      if (i.ge.m) then
         s(i:)=s(i+lc:)
         ls=ls-lc
         s(ls+1:)=' '
         goto 101
      else
         return
      endif
      end
         

      subroutine replace_in_string (s,c,d,m,n)
c
c Shift and pad when len(c).gt.len(d):
c s,c,d,m,0      - replace all c by d in s(m:) and pad blanks at right end.
c s,c,d,m,n      -     "    "  c by d in s(m:n), shift s(n+1:) to the left.
c s(m:n),c,d,1,0 -     "    "  c by d in s(m:n), leave s(n+1:) intact. 
c s,c,d,m,n      - If n < m then n will be set equal to m.                     
c
c len(c).lt.len(d) causes an error
c
c The sequence
c     m=index(s,c)
c     call replace_in_string (s,c,d,m,m)
c will replace the first occurrence of c in s.
c
      character s*(*), c*(*), d*(*)
      lsi=len(s)
      if (n.le.0) then
         lse=lsi
      else
         lse=n
      endif
      if (lse.gt.0.and.lse.le.m) lse=min0(m+1,lsi)
      lc=len(c)-1
      ld=len(d)-1
      if (max0(lc,ld).gt.lse) then
         print '(a,3i4)'
     &,        ' <RepISt>T> Target/replacement longer than string. '
     &,         lc,ld,lse
         stop
      endif
      lcd=lc-ld
c      print '(a,2i4)',' <repins>>> ',lc,ld
      if (lcd.lt.0) goto 200
      if (lcd.gt.0) goto 300
      
      i=m-1
101   i=i+1
      if (i.gt.lse-ld) return
      if (s(i:i+ld).eq.c) then
         s(i:i+ld)=d
         i=i+ld
      endif
      goto 101
      
300   lse=lse+lcd

302   lse=lse-lcd
      i=index(s(m:lse),c)+m-1
      if (i.lt.m.or.i.gt.lse) return
      do jj=1,ld+1
         j=jj+i-1
         s(j:j)=d(jj:jj)
      enddo
      do j=ld+i+1,lse-lcd
         jj=j+lcd
         s(j:j)=s(jj:jj)
      enddo
      do j=lse+lcd+1,lse
         s(j:j)=' '
      enddo
      goto 302
      
200   lsb=m
      print *,'lc,ld,lsb,lse,m=',lc,ld,lsb,lse,m
      
 201  if (lse-lsb.lt.lc) return
      i=index(s(lsb:lse),c)+lsb-1
      if (i.lt.lsb) return
      do jj=lsi,i+ld+1,-1
         s(jj:jj)=s(jj+lcd:jj+lcd)
      enddo
      s(i:i+ld)=d
      lsb=lsb+ld+1
      lse=min0(lse,lse-lcd)
      goto 201
      

c201   if (lse.lt.m) return
c      i=index(s(lsb:lse),c)+lsb-1
c      if (i.lt.lsb) then
c         lsb=lsb-1
c         if (lsb.ge.m) goto 201
c         return
c      endif
c      lsb=i
c      lse=lsb+lc
c      do jj=lsi,i+ld+1,-1
c         s(jj:jj)=s(jj+lcd:jj+lcd)
c      enddo
c      s(i:i+ld)=d
c      lsb=lsb+ld
c      goto 201
      
      end


      
C:Provides  subroutine ucase F=ucase.f
C:Provides  subroutine lcase F=ucase.f
C:Provides  subroutine delete_1_in_string F=ucase.f
C:Provides  subroutine delete_l_in_string F=ucase.f
C:Provides  subroutine delete_in_string F=ucase.f
C:Provides  subroutine replace_in_string F=ucase.f
